<id>
LHVWB:ChooseIgnorableBoards
</id>

<version>
1.2
</version>

<edit file>
$sourcedir/Load.php
</edit file>

<search for>
'ignoreboards' => !empty($user_settings['ignore_boards']) && !empty($modSettings['allow_ignore_boards']) ? explode(',', $user_settings['ignore_boards']) : array(),
</search for>

<replace>
'ignoreboards' => !empty($user_settings['ignore_boards']) && !empty($modSettings['allow_ignore_boards']) && !empty($modSettings['ignorable_boards_cache']) ? explode(',', $user_settings['ignore_boards']) : array(),
</replace>

<search for>
	// Make sure that the last item in the ignore boards array is valid.  If the list was too long it could have an ending comma that could cause problems.
	if (!empty($user_info['ignoreboards']) && empty($user_info['ignoreboards'][$tmp = count($user_info['ignoreboards']) - 1]))
		unset($user_info['ignoreboards'][$tmp]);
</search for>

<replace>
	// Make sure that the last item in the ignore boards array is valid.  If the list was too long it could have an ending comma that could cause problems.
	if (!empty($user_info['ignoreboards']) && empty($user_info['ignoreboards'][$tmp = count($user_info['ignoreboards']) - 1]))
		unset($user_info['ignoreboards'][$tmp]);

	// Not a Superman? You might be trying to ignore some boards that you just can't. ;)
	if (!allowedTo('admin_forum'))
	{
		$ignorable_boards = !empty($modSettings['ignorable_boards_cache']) ? unserialize($modSettings['ignorable_boards_cache']) : array();
		// Can you really ignore those boards?
		if (!empty($ignorable_boards))
		{
			foreach ($user_info['ignoreboards'] as $temp_id => $board_id)
			{
				// Assume failure!
				$fail = true;
				// Check to see if they can ignore that board.
				if (!empty($ignorable_boards[$board_id]))
				{
					foreach ($ignorable_boards[$board_id] as $group)
					{
						if (in_array($group, $user_info['groups']))
						{
							$fail = false;
							break;
						}
					}
				}
				// Too bad, you just can't ignore that board!
				if($fail)
					unset($user_info['ignoreboards'][$temp_id]);
			}
		}
		// We had better stop everything...
		else
			$user_info['ignoreboards'] = array();
	}
</replace>

<edit file>
$sourcedir/Profile-Modify.php
</edit file>

<search for>
		// This category hasn't been set up yet..
</search for>

<replace>
		// We only need to check this if they don't have super powers. Admin can fly, its true!
		if (!allowedTo('admin_forum'))
		{
			// Hmm... Are you sure you can actually ignore this board?
			$ignore_boards = !empty($modSettings['ignorable_boards_cache']) ? unserialize($modSettings['ignorable_boards_cache']) : array();
			$ignore_membergroups = !empty($ignore_boards[$row['id_board']]) ? $ignore_boards[$row['id_board']] : array();

			// Assume failure.
			$fail = true;
			foreach ($ignore_membergroups as $val)
			{
				$val = (int) $val;
				if (in_array($val, $user_info['groups']))
					$fail = false;
			}
			// Naughty, naughty!
			if ($fail)
				continue;
		}

		// This category hasn't been set up yet..
</replace>

<edit file>
$sourcedir/Profile.php
</edit file>

<search for>
					'enabled' => !empty($modSettings['allow_ignore_boards']),
</search for>

<replace>
					'enabled' => !empty($modSettings['allow_ignore_boards']) && can_user_ignore_boards(),
</replace>

<search for>
?>
</search for>

<replace>
// Determine if a user can actually ignore any boards.
function can_user_ignore_boards()
{
	global $modSettings, $user_info;

	// Admin can ignore whatever they like. ;)
	if (allowedTo('admin_forum'))
		return true;

	// Lets try to find a single board that they can ignore.
	$ignorable_boards = unserialize($modSettings['ignorable_boards_cache']);
	
	// Assume failure!
	$return = false;
	// Check each board.
	foreach ($ignorable_boards as $ignore_membergroups)
	{
		// Check to see if they can ignore that board.
		foreach ($ignore_membergroups as $group)
		{
			if (in_array($group, $user_info['groups']))
			{
				$return = true;
				break 2;
			}
		}
	}
	return $return;
}

?>
</replace>

<edit file>
$sourcedir/Subs-Boards.php
</edit file>

<search for>
	// Who's allowed to access this board.
	if (isset($boardOptions['access_groups']))
	{
		$boardUpdates[] = 'member_groups = {string:member_groups}';
		$boardUpdateParameters['member_groups'] = implode(',', $boardOptions['access_groups']);
	}
</search for>

<replace>
	// Who's allowed to access this board.
	if (isset($boardOptions['access_groups']))
	{
		$boardUpdates[] = 'member_groups = {string:member_groups}';
		$boardUpdateParameters['member_groups'] = implode(',', $boardOptions['access_groups']);
	}
	
	// Updating the membergroups that can ignore this board?
	if (isset($boardOptions['ignore_groups']))
	{
		$ignore_boards = !empty($modSettings['ignorable_boards_cache']) ? unserialize($modSettings['ignorable_boards_cache']) : array();
		$ignore_boards[$board_id] = $boardOptions['ignore_groups'];
		updateSettings(array('ignorable_boards_cache' => serialize($ignore_boards)));
	}
</replace>

<search for>
		'access_groups' => array(),
</search for>

<replace>
		'access_groups' => array(),
		'ignore_groups' => !empty($modSettings['ChooseIgnorableBoards_default']) ? explode(',', $modSettings['ChooseIgnorableBoards_default']) : array(),
</replace>

<edit file>
$sourcedir/ManageBoards.php
</edit file>

<search for>
		'settings' => array('EditBoardSettings', 'admin_forum'),
</search for>

<replace>
		'settings' => array('EditBoardSettings', 'admin_forum'),
		'ignoreprofiles' => array('IgnoreProfiles', 'admin_forum'),
</replace>

<search for>
			'category' => (int) $_REQUEST['cat'],
</search for>

<replace>
			'category' => (int) $_REQUEST['cat'],
			'ignore_groups' => !empty($modSettings['ChooseIgnorableBoards_default']) ? explode(',', $modSettings['ChooseIgnorableBoards_default']) : array(),
</replace>

<search for>
		$context['board']['is_recycle'] = !empty($modSettings['recycle_enable']) && !empty($modSettings['recycle_board']) && $modSettings['recycle_board'] == $context['board']['id'];
</search for>

<replace>
		$context['board']['is_recycle'] = !empty($modSettings['recycle_enable']) && !empty($modSettings['recycle_board']) && $modSettings['recycle_board'] == $context['board']['id'];
		$ignore_boards = !empty($modSettings['ignorable_boards_cache']) ? unserialize($modSettings['ignorable_boards_cache']) : array();
		$context['board']['ignore_groups'] = !empty($ignore_boards[$context['board']['id']]) ? $ignore_boards[$context['board']['id']]: array();
</replace>

<search for>
	foreach ($boardList[$curBoard['category']] as $boardid)
</search for>

<replace>
	// Do the ignorable groups as well. :)
	$context['ignore_groups'] = $context['groups'];
	unset($context['ignore_groups'][-1]);
	foreach ($context['ignore_groups'] as $group_id => $group)
		$context['ignore_groups'][$group_id]['checked'] = in_array($group_id, $context['board']['ignore_groups']);

	foreach ($boardList[$curBoard['category']] as $boardid)
</replace>

<search for>
		// Change '1 & 2' to '1 &amp; 2', but not '&amp;' to '&amp;amp;'...
</search for>

<replace>
		$boardOptions['ignore_groups'] = array();
		if (!empty($_POST['ignore_groups']))
			foreach ($_POST['ignore_groups'] as $group)
				$boardOptions['ignore_groups'][] = (int) $group;

		// Change '1 & 2' to '1 &amp; 2', but not '&amp;' to '&amp;amp;'...
</replace>

<search for>
	while ($row = $smcFunc['db_fetch_assoc']($request))
		$recycle_boards[$row['id_board']] = $row['cat_name'] . ' - ' . $row['board_name'];
	$smcFunc['db_free_result']($request);
</search for>

<replace>
	while ($row = $smcFunc['db_fetch_assoc']($request))
		$recycle_boards[$row['id_board']] = $row['cat_name'] . ' - ' . $row['board_name'];
	$smcFunc['db_free_result']($request);
	
	$default_ignore_profile = !empty($modSettings['ChooseIgnorableBoards_default']) ? explode(',', $modSettings['ChooseIgnorableBoards_default']) : array();
	// Default membergroups.
	$context['groups'] = array(
		0 => array(
			'id' => '0',
			'name' => $txt['parent_members_only'],
			'checked' => in_array('0', $default_ignore_profile),
			'is_post_group' => false,
		)
	);

	// Load membergroups.
	$request = $smcFunc['db_query']('', '
		SELECT group_name, id_group, min_posts
		FROM {db_prefix}membergroups
		WHERE id_group > {int:moderator_group} OR id_group = {int:global_moderator}
		ORDER BY min_posts, id_group != {int:global_moderator}, group_name',
		array(
			'moderator_group' => 3,
			'global_moderator' => 2,
		)
	);
	while ($row = $smcFunc['db_fetch_assoc']($request))
	{
		$context['groups'][(int) $row['id_group']] = array(
			'id' => $row['id_group'],
			'name' => trim($row['group_name']),
			'checked' => in_array($row['id_group'], $default_ignore_profile),
			'is_post_group' => $row['min_posts'] != -1,
		);
	}
	$smcFunc['db_free_result']($request);
</replace>

<search for>
			array('check', 'allow_ignore_boards'),
</search for>

<replace>
			array('title', 'ChooseIgnorableBoards_title'),
			array('check', 'allow_ignore_boards'),
			array('callback', 'default_ignore_fieldset'),
		'',
			array('message', 'ChooseIgnorableBoards_applyprofile'),
</replace>

<search for>
	// Doing a save?
	if (isset($_GET['save']))
	{
		checkSession();

		saveDBSettings($config_vars);
		redirectexit('action=admin;area=manageboards;sa=settings');
	}
</search for>

<replace>
	// Doing a save?
	if (isset($_GET['save']))
	{
		checkSession();

		// Update the default ignored groups profile.
		$default_ignore_groups = array();
		if (!empty($_POST['ignore_groups']))
		{
			foreach ($_POST['ignore_groups'] as $group)
				$default_ignore_groups[] = $group;
		}
		updateSettings(array('ChooseIgnorableBoards_default' => implode(',', $default_ignore_groups)));

		saveDBSettings($config_vars);
		redirectexit('action=admin;area=manageboards;sa=settings');
	}
	
	// Applying a profile? This bit gets fun!
	if (isset($_GET['applyprofile']))
	{
		$ignore_boards = !empty($modSettings['ignorable_boards_cache']) ? unserialize($modSettings['ignorable_boards_cache']) : array();
		
		// Get the new profile.
		$profile = array();
		if (!empty($_POST['ignore_groups']))
		{
			foreach ($_POST['ignore_groups'] as $group)
				$profile[] = (int) $group;
		}

		// Update the profile for each relevant board. 
		if (!empty($_POST['ignore_boards']))
		{
			foreach ($_POST['ignore_boards'] as $board)
			{
				$ignore_boards[$board] = $profile;
			}
		}

		// Update the ignore board options and redirect.
		updateSettings(array('ignorable_boards_cache' => serialize($ignore_boards)));
		redirectexit('action=admin;area=manageboards;sa=settings;profileconfirm');
	}

	// Give a confirmation message.
	if (isset($_GET['profileconfirm']))
		$context['settings_message'] = '<span style="color: green;">'.$txt['ChooseIgnorableBoards_applyprofile_confirm'].'</span>';
</replace>

<search for>
?>
</search for>

<replace>
// This function lets admin easily assign a series of boards with the same ignore boards options.
function IgnoreProfiles()
{
	global $context, $sourcedir, $smcFunc, $txt, $cat_tree, $boardList, $boards;

	// Setup the correct templates.
	loadTemplate('ManageBoards');
	$context['sub_template'] = 'ignore_profile';
	$context['page_title'] = $txt['ChooseIgnorableBoards_title'];

	// Default membergroups.
	$context['groups'] = array(
		0 => array(
			'id' => '0',
			'name' => $txt['parent_members_only'],
			'is_post_group' => false,
		)
	);

	// Load membergroups.
	$request = $smcFunc['db_query']('', '
		SELECT group_name, id_group, min_posts
		FROM {db_prefix}membergroups
		WHERE id_group > {int:moderator_group} OR id_group = {int:global_moderator}
		ORDER BY min_posts, id_group != {int:global_moderator}, group_name',
		array(
			'moderator_group' => 3,
			'global_moderator' => 2,
		)
	);
	while ($row = $smcFunc['db_fetch_assoc']($request))
	{
		$context['groups'][(int) $row['id_group']] = array(
			'id' => $row['id_group'],
			'name' => trim($row['group_name']),
			'is_post_group' => $row['min_posts'] != -1,
		);
	}
	$smcFunc['db_free_result']($request);
	
	// Load boards
	require_once($sourcedir . '/Subs-Boards.php');
	getBoardTree();

	// Structure boards/categories.
	$context['categories'] = array();
	foreach ($cat_tree as $catid => $tree)
	{
		$context['categories'][$catid] = array(
			'name' => &$tree['node']['name'],
			'boards' => array(),
			'child_ids' => array(),
		);

		foreach ($boardList[$catid] as $boardid)
		{
			$context['categories'][$catid]['boards'][$boardid] = array(
				'id' => &$boards[$boardid]['id'],
				'name' => &$boards[$boardid]['name'],
				'child_level' => $boards[$boardid]['level'],
			);
			$context['categories'][$catid]['child_ids'][] = $boardid;
		}
	}
}

?>
</replace>

<edit file>
$themedir/ManageBoards.template.php
</edit file>

<search for>
	// Here the user can choose to force this board to use a theme other than the default theme for the forum.
</search for>

<replace>
	echo '
					<div id="ignorable_membergroupds_div">
						<dl class="settings">
							<dt>
								<strong>', $txt['ChooseIgnorableBoards_board'], ':</strong><br />
								<span class="smalltext">', $txt['ChooseIgnorableBoards_board_desc'], '</span><br />
							</dt>
							<dd>
							<fieldset style="display: block;" id="ignorable_membergroups">
								<legend><a href="javascript:void(0);" onclick="document.getElementById(\'ignorable_membergroups\').style.display = \'none\';document.getElementById(\'ignorable_membergroups_groups_link\').style.display = \'block\'; return false;">', $txt['ChooseIgnorableBoards_board_toggle'], '</a></legend>';

	// List all the membergroups so the user can choose who may access this board.
	foreach ($context['ignore_groups'] as $group)
		echo '
									<label for="ignore_groups_', $group['id'], '"><input type="checkbox" name="ignore_groups[]" value="', $group['id'], '" id="ignore_groups_', $group['id'], '"', $group['checked'] ? ' checked="checked"' : '', ' /><span', $group['is_post_group'] ? ' style="border-bottom: 1px dotted;" title="' . $txt['mboards_groups_post_group'] . '"' : '', '>', $group['name'], '</span></label><br />';

	echo '
								<i>', $txt['check_all'], '</i> <input type="checkbox" onclick="invertAll(this, this.form, \'ignore_groups[]\');" /><br />
							</fieldset>
							<a href="javascript:void(0);" onclick="document.getElementById(\'ignorable_membergroups\').style.display = \'block\'; document.getElementById(\'ignorable_membergroups_groups_link\').style.display = \'none\'; return false;" id="ignorable_membergroups_groups_link" style="display: none;">[ ', $txt['ChooseIgnorableBoards_board_toggle'], ' ]</a>

							<script language="JavaScript" type="text/javascript"><!-- // --><![CDATA[
								document.getElementById("ignorable_membergroups").style.display = "none";
								document.getElementById("ignorable_membergroups_groups_link").style.display = "";
							// ]]></script>
							</dd>
						</dl>
					</div>';

	// Here the user can choose to force this board to use a theme other than the default theme for the forum.
</replace>

<search for>
			document.getElementById("count_posts_div").style.display = redirectEnabled ? "none" : "";
</search for>

<replace>
			document.getElementById("count_posts_div").style.display = redirectEnabled ? "none" : "";
			document.getElementById("ignorable_div").style.display = redirectEnabled ? "none" : "";
</replace>

<search for>
?>
</search for>

<replace>
function template_callback_default_ignore_fieldset()
{
	global $txt, $context;
	
	echo '
		<dt>
			', $txt['ChooseIgnorableBoards_default'], '<br />
			<span class="smalltext">', $txt['ChooseIgnorableBoards_default_desc'], '</span><br />
		</dt>
		<dd>
			<fieldset id="ignorable_membergroups">
				<legend><a href="javascript:void(0);" onclick="document.getElementById(\'ignorable_membergroups\').style.display = \'none\';document.getElementById(\'ignorable_membergroups_groups_link\').style.display = \'block\'; return false;">', $txt['ChooseIgnorableBoards_default_toggle'], '</a></legend>';
	
	// List all the membergroups so the user can choose who may access this board.
	foreach ($context['groups'] as $group)
		echo '
				<label for="ignore_groups_', $group['id'], '"><input type="checkbox" name="ignore_groups[]" value="', $group['id'], '" id="ignore_groups_', $group['id'], '"', $group['checked'] ? ' checked="checked"' : '', ' /><span', $group['is_post_group'] ? ' style="border-bottom: 1px dotted;" title="' . $txt['mboards_groups_post_group'] . '"' : '', '>', $group['name'], '</span></label><br />';

	echo '
				<i>', $txt['check_all'], '</i> <input type="checkbox" onclick="invertAll(this, this.form, \'ignore_groups[]\');" /><br />
			</fieldset>
			<a href="javascript:void(0);" onclick="document.getElementById(\'ignorable_membergroups\').style.display = \'block\'; document.getElementById(\'ignorable_membergroups_groups_link\').style.display = \'none\'; return false;" id="ignorable_membergroups_groups_link" style="display: none;">[ ', $txt['ChooseIgnorableBoards_default_toggle'], ' ]</a>

			<script language="JavaScript" type="text/javascript"><!-- // --><![CDATA[
				document.getElementById("ignorable_membergroups").style.display = "none";
				document.getElementById("ignorable_membergroups_groups_link").style.display = "";
			// ]]></script>
		</dd>';
}

function template_ignore_profile()
{
	global $txt, $context, $scripturl;
	
	echo '
	<form action="', $scripturl, '?action=admin;area=manageboards;sa=settings;applyprofile" method="post" accept-charset="', $context['character_set'], '" name="applyprofile" id="applyprofile">
		<div style="width: 80%; margin: auto;">
			<div class="cat_bar">
				<h3 class="catbg">
					<a href="', $scripturl, '?action=admin;area=manageboards;sa=settings">', $txt['ChooseIgnorableBoards_title'], '</a> >  ', $txt['ChooseIgnorableBoards_applyprofile_title'],  '
				</h3>
			</div>
			<div class="windowbg2">
				<span class="topslice"><span></span></span>
				<div class="content">
					<dl class="settings">
						<dt>
							<b>', $txt['ChooseIgnorableBoards_applyprofile_groups'], '</b><br />
							<span class="smalltext">', $txt['ChooseIgnorableBoards_applyprofile_groups_desc'], '</span><br />
						</dt>
						<dd>';
					
					// List all the membergroups so the user can choose who may access this board.
					foreach ($context['groups'] as $group)
						echo '
							<label for="ignore_groups_', $group['id'], '"><input type="checkbox" name="ignore_groups[]" value="', $group['id'], '" id="ignore_groups_', $group['id'], '" /><span', $group['is_post_group'] ? ' style="border-bottom: 1px dotted;" title="' . $txt['mboards_groups_post_group'] . '"' : '', '>', $group['name'], '</span></label><br />';

					echo '
							<i>', $txt['check_all'], '</i> <input type="checkbox" onclick="invertAll(this, this.form, \'ignore_groups[]\');" /><br /><br />
						</dd>
						<dt>
								<b>', $txt['ChooseIgnorableBoards_applyprofile_boards'], '</b><br />
								<span class="smalltext">', $txt['ChooseIgnorableBoards_applyprofile_boards_desc'], '</span><br />
						</dt>
						<dd>
							<script language="JavaScript" type="text/javascript"><!-- // --><![CDATA[
								function selectBoards(ids)
								{
									var toggle = true;

									for (i = 0; i < ids.length; i++)
										toggle = toggle & document.forms.applyprofile["ignore_boards_" + ids[i]].checked;

									for (i = 0; i < ids.length; i++)
										document.forms.applyprofile["ignore_boards_" + ids[i]].checked = !toggle;
								}
							// ]]></script>';
					
					// List every board, separated by categories.
					foreach ($context['categories'] as $cat)
					{
						if (empty($cat['boards']))
							continue;

						echo '
							<b><a href="javascript:void(0);" onclick="selectBoards([', implode(', ', $cat['child_ids']), ']); return false;" style="text-decoration: underline;">', $cat['name'], '</a></b><br />';
						
						foreach ($cat['boards'] as $board)
							echo '
							<label for="ignore_boards_', $board['id'], '" style="margin-left: ', $board['child_level'], 'ex;"><input type="checkbox" name="ignore_boards[]" value="', $board['id'], '" id="ignore_boards_', $board['id'], '" />', $board['name'], '</label><br />';
					}

					echo '
							<i>', $txt['check_all'], '</i> <input type="checkbox" onclick="invertAll(this, this.form, \'ignore_boards[]\');" /><br />
						</dd>
					</dl>
					<div class="righttext">
						<input type="submit" value="', $txt['save'], '" class="button_submit" />
					</div>
				</div>
				<span class="botslice"><span></span></span>
			</div>
		</div>
	</form>';
}

?>
</replace>