<?php
// Handle running this file by using SSI.php
if (file_exists(dirname(__FILE__) . '/SSI.php') && !defined('SMF'))
	require_once(dirname(__FILE__) . '/SSI.php');
elseif (!defined('SMF'))
	die('<b>Error:</b> Cannot install - please verify you put this in the same place as SMF\'s index.php.');

// Load the membergroups.
$request = $smcFunc['db_query']('', '
	SELECT id_group
	FROM {db_prefix}membergroups
	WHERE id_group != {int:moderator_group}
		AND id_group != {int:admin_group}',
	array(
		'moderator_group' => 3,
		'admin_group' => 1,
	)
);

// Get us some ids.
$membergroups = array(0);
while ($row = $smcFunc['db_fetch_assoc']($request))
	$membergroups[] = $row['id_group'];
	
// Don't forget to free the request!!!
$smcFunc['db_free_result']($request);

// Lets see about the actual installation. ;)
global $modSettings;
$updates = array();
// Clean install?
if (!empty($modSettings['allow_ignore_boards']) && empty($modSettings['ignorable_boards_cache']))
{
	// Lets make a temp list of boards.
	$temp_boards = array();
	$request = $smcFunc['db_query']('', '
		SELECT id_board
		FROM {db_prefix}boards
		WHERE redirect = {string:empty_string}',
		array(
			'empty_string' => '',
		)
	);
	while ($row = $smcFunc['db_fetch_assoc']($request))
		$temp_boards[$row['id_board']] = $membergroups;
	$smcFunc['db_free_result']($request);

	// We'll need to add all those boards to the ignore cache.
	if (!empty($temp_boards))
		$updates['ignorable_boards_cache'] = serialize($temp_boards);

	// We should probably set our default ignore options to all membergroups as well.
	$updates['ChooseIgnorableBoards_default'] = implode(',', $membergroups);
}
// Updating from an older version?
elseif (!empty($modSettings['ignorable_boards_cache']))
{
	// If we can unserialize the cache, then don't bother with updates...
	if (!unserialize($modSettings['ignorable_boards_cache']))
	{
		// Convert any past list of ignorable boards.
		$boards = explode(',', $modSettings['ignorable_boards_cache']);
		$temp_boards = array();
		foreach ($boards as $board)
		{			
			$board = (int) $board;
			if (!empty($board))
				$temp_boards[$board] = $membergroups;
		}

		// We'll need to add all those boards to the ignore cache.
		if (!empty($temp_boards))
			$updates['ignorable_boards_cache'] = serialize($temp_boards);

		// Another setting to update?
		if (!empty($modSettings['ChooseIgnorableBoards_default']))
			$updates['ChooseIgnorableBoards_default'] = implode(',', $membergroups);
	}
}

// Any updates?
if (!empty($updates))
	updateSettings($updates);

// Show a confirmation message, if an upgrade through SSI.php was successful.
if(SMF == 'SSI')
   echo 'Database Upgrade Complete!';

?>